void send4digits(int val){
  digitalWrite(DIMM,LOW);
  if(val<10){transferX(decodNum(val)); transferX(0x00);transferX(0x00);transferX(0x00);}
  else if(val<100){transferX(decodNum(val%10));transferX(decodNum((int)val/10));transferX(0x00);transferX(0x00);}
  else if(val<1000){transferX(decodNum(val%10));transferX(decodNum((int)(val%100)/10));transferX(decodNum((int)val/100));transferX(0x00);}
  else{ transferX(decodNum(val%10));transferX(decodNum((int)(val%100)/10));transferX(decodNum((int)(val%1000)/100));transferX(decodNum((int)val/1000)); }
  digitalWrite(DIMM,HIGH);
}

int decodNum(int a){
  switch (a) {
    case 0:
      return 0xfc;  break;
    case 1:
      return 0x60;  break;
    case 2:
      return 0xda;  break;
    case 3:
      return 0xf2;  break;
    case 4:
      return 0x66;  break;
    case 5:
      return 0xb6;  break;
    case 6:
      return 0xbe;  break;
    case 7:
      return 0xe0;  break;
    case 8:
      return 0xfe;  break;
    case 9:
      return 0xf6;  break;
    default: 
      return 0xFF;
  }
}

int decodChar(char a){
  switch (a) {
    case '0':
      return 0xfc;  break;
    case '1':
      return 0x60;  break;
    case '2':
      return 0xda;  break;
    case '3':
      return 0xf2;  break;
    case '4':
      return 0x66;  break;
    case '5':
      return 0xb6;  break;
    case '6':
      return 0xbe;  break;
    case '7':
      return 0xe0;  break;
    case '8':
      return 0xfe;  break;
    case '9':
      return 0xf6;  break;
    case 'a':
      return 0xee;  break;
    case 'b':
      return 0x3e;  break;
    case 'c':
      return 0x1a;  break;
    case 'd':
      return 0x7a;  break;
    case 'E':
      return 0x9e;  break;
    case 'f':
      return 0x8e;  break;
    case 'g':
      return 0xf6;  break;
    case 'h':
      return 0x6e;  break;
    case 'i':
      return 0x60;  break;
    case 'j':
      return 0x70;  break;
    case 'l':
      return 0x1c;  break;
    case 'n':
      return 0x2a;  break;
    case 'o':
      return 0x3a;  break;
    case 'p':
      return 0xda;  break;
    case 'Q':
      return 0xe6;  break;
    case 'r':
      return 0x0a;  break;
    case 's':
      return 0xb6;  break;
    case 't':
      return 0xe0;  break;
    case 'u':
      return 0x38;  break;
    case 'y':
      return 0x76;  break;
    case ' ':
      return 0x00;  break;
    default: 
      return 0xFF;
  }
}

void printDisp(String s){
  digitalWrite(DIMM,LOW);
  if (s.length()<4){
    for(int i=0; i<4-s.length(); i++){      transferX(0x00);    }
    for(int i=0; i<s.length(); i++)  {      transferX(decodChar(s[s.length()-1-i]));}
  }
  else{
    for(int i=0; i<s.length(); i++)  {      transferX(decodChar(s[s.length()-1-i]));}
  }
  digitalWrite(DIMM,HIGH);
}

void clearDisp(){
  digitalWrite(DIMM,LOW);transferX(0x01);digitalWrite(DIMM,HIGH);
}

void transferX(int b){
  shiftOut(MOSIx, CLK, LSBFIRST, b) ;
}
